Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Interface Searchable

All Superinterfaces:
  Remote

All Known Implementing Classes:
  RemoteSearchable, Searcher

public interface Searchable
extends Remote

The interface for search implementations.

Implementations provide search over a single index, over multiple indices, and over indices on remote servers.

Method Summary
`void` | `close()` Frees resources associated with this Searcher.
`Document` | `doc(int i)` Expert: Returns the stored fields of document `i`.
`int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
`Explanation` | `explain(Query query, int doc)` Returns an Explanation that describes how `doc` scored against `query`.
`int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
`Query` | `rewrite(Query query)` Expert: called to re-write queries into primitive queries.
`void` | `search(Query query, Filter filter, HitCollector results)` Lower-level search API.
`TopDocs` | `search(Query query, Filter filter, int n)` Expert: Low-level search implementation.
`TopFieldDocs` | `search(Query query, Filter filter, int n, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.

Method Detail

### search

    public void search(Query query,
                       Filter filter,
                       HitCollector results)
                throws IOException

  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every non-zero scoring document.

  Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Parameters:
    `query` - to match documents
    `filter` - if non-null, a bitset used to eliminate some documents
    `results` - to receive hits
  Throws:
    `IOException`

### close

    public void close()
               throws IOException

  Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects like `Hits`.

  Throws:
    `IOException`

### docFreq

    public int docFreq(Term term)
                throws IOException

  Expert: Returns the number of documents containing `term`. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.docFreq(Term).`

### maxDoc

    public int maxDoc()
               throws IOException

  Expert: Returns one greater than the largest possible document number. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.maxDoc().`

### search

    public TopDocs search(Query query,
                          Filter filter,
                          int n)
                   throws IOException

  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Called by `Hits`.

  Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

  Throws:
    `IOException`

### doc

    public Document doc(int i)
                 throws IOException

  Expert: Returns the stored fields of document `i`. Called by `HitCollector` implementations.

  Throws:
    `IOException`
  See Also:
    `IndexReader.document(int).`

### rewrite

    public Query rewrite(Query query)
                  throws IOException

  Expert: called to re-write queries into primitive queries.

  Throws:
    `IOException`

### explain

    public Explanation explain(Query query,
                               int doc)
                        throws IOException

  Returns an Explanation that describes how `doc` scored against `query`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Throws:
    `IOException`

### search

    public TopFieldDocs search(Query query,
                               Filter filter,
                               int n,
                               Sort sort)
                        throws IOException

  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `Searcher.search(Query,Filter,Sort)` instead.

  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2005 Apache Software Foundation. All Rights Reserved.